﻿<?php
/*
$Id$

Zencart PaymentSense Re-Direct Payment Module
Copyright (C) 2011 PaymentSense.
Support: ecomsupport@paymentsense.com

------------------------

Last Updated: 13/12/2011

------------------------

Released under the GNU General Public License
*/
	global $db, $order, $order_total_modules, $currencies, $currency, $cartID, $code, $title, $description, $enabled, $db;
	
	//Used to store the original store settings, we need to overwrite them and set them back again
	define('STOCK_LIMITED', 'false');
	$orig_STOCK_LIMITED = STOCK_LIMITED;
	
	chdir('../../../../');
	require_once('includes/application_top.php');	
	require_once(DIR_WS_CLASSES . 'shipping.php');
	require_once(DIR_WS_CLASSES . 'payment.php');
	require_once(DIR_WS_CLASSES . 'order.php');
	require_once(DIR_WS_CLASSES . 'order_total.php');
	$payment_modules = new payment($_SESSION['payment']);
	$shipping_modules = new shipping($_SESSION['shipping']);
	$order = new order();
	$order_total_modules = new order_total;
	$order_totals = $order_total_modules->process();	
	$insert_id = $order->create($order_totals);	
	$order->create_add_products($insert_id);
	require_once(DIR_WS_LANGUAGES . 'english/checkout_process.php');
	$order->send_order_email($insert_id);
	$cartID = $insert_id;
	$_SESSION['cartID'] = $cartID;
	
	define('STOCK_LIMITED', $orig_STOCK_LIMITED);
	
	switch (MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_CURRENCY) {
		case 'GBP':
		  $cs_currency = 826;
		  break;
		case 'EUR':
		  $cs_currency = 978;
		  break;
		case 'USD':
		  $cs_currency = 840;
		  break;
	}

	//Get country ISO Code
	require_once(DIR_WS_MODULES . 'payment/paymentsense_redirect/Common.php');
	require_once(DIR_WS_MODULES . 'payment/paymentsense_redirect/ISOCountries.php');
					
	$country_code = 0;

	$zen_country_code = $order->billing['country']['iso_code_3'];

	for ($country_i = 0; $country_i < $iclISOCountryList->getCount() - 1; $country_i++) {
		if ($iclISOCountryList->getAt($country_i)->getCountryNameShort() == $zen_country_code) {
			$country_code = $iclISOCountryList->getAt($country_i)->getISOCode();
			break;
		}
	}

	if (is_null($country_code)) {
		$country_code = 0;
	}

	$nCountryCode = $country_code;

	//Get server date/time
	$gatewaydatetime = date('Y-m-d H:i:s O');

	$OrderAmount = $order->info['total']*100;

	$OrderDescription = STORE_NAME . " " . date('Ymdhis');

	$CustomerName = $order->billing['firstname'] . ' ' . $order->billing['lastname'];
	$Address1 = $order->billing['street_address'];
	$Address2 = $order->billing['suburb'];
	$Address3 = "";
	$Address4 = "";
	$City = $order->billing['city'];
	$State = $order->billing['state'];
	$PostCode = $order->billing['postcode'];

	$CallbackURL = HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_MODULES . "payment/paymentsense_redirect/callback.php";
	$ServerResultURL = HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_MODULES . "payment/paymentsense_redirect/serverresult.php";

	$CV2Mandatory = "TRUE";
	$Address1Mandatory = "TRUE";
	$CityMandatory = "TRUE";
	$PostCodeMandatory = "TRUE";
	$StateMandatory = "TRUE";
	$CountryMandatory = "TRUE";

	// Calculate the digest to send
	$digest_string = "PreSharedKey=" . MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_PRESHARED_KEY;
	$digest_string = $digest_string . '&MerchantID=' . MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_ID;
	$digest_string = $digest_string . '&Password=' . MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_PASSWORD;
	$digest_string = $digest_string . '&Amount=' . $OrderAmount;
	$digest_string = $digest_string . '&CurrencyCode=' . $cs_currency;
	$digest_string = $digest_string . '&OrderID=' . $cartID;
	$digest_string = $digest_string . '&TransactionType=' . "SALE";
	$digest_string = $digest_string . '&TransactionDateTime=' . $gatewaydatetime;
	$digest_string = $digest_string . '&CallbackURL=' . $CallbackURL;
	$digest_string = $digest_string . '&OrderDescription=' . $OrderDescription;
	$digest_string = $digest_string . '&CustomerName=' . $CustomerName;
	$digest_string = $digest_string . '&Address1=' . $Address1;
	$digest_string = $digest_string . '&Address2=' . $Address2;
	$digest_string = $digest_string . '&Address3=' . $Address3;
	$digest_string = $digest_string . '&Address4=' . $Address4;
	$digest_string = $digest_string . '&City=' . $City;
	$digest_string = $digest_string . '&State=' . $State;
	$digest_string = $digest_string . '&PostCode=' . $PostCode;
	$digest_string = $digest_string . '&CountryCode=' . $nCountryCode;
	$digest_string = $digest_string . "&CV2Mandatory=" . $CV2Mandatory;
	$digest_string = $digest_string . "&Address1Mandatory=" . $Address1Mandatory;
	$digest_string = $digest_string . "&CityMandatory=" . $CityMandatory;
	$digest_string = $digest_string . "&PostCodeMandatory=" . $PostCodeMandatory;
	$digest_string = $digest_string . "&StateMandatory=" . $StateMandatory;
	$digest_string = $digest_string . "&CountryMandatory=" . $CountryMandatory;
	$digest_string = $digest_string . "&ResultDeliveryMethod=" . 'SERVER';
	$digest_string = $digest_string . "&ServerResultURL=" . $ServerResultURL;
	$digest_string = $digest_string . "&PaymentFormDisplaysResult=" . 'FALSE';
	$digest_string = $digest_string . "&ServerResultURLCookieVariables=" . '';
	$digest_string = $digest_string . "&ServerResultURLFormVariables=" . '';
	$digest_string = $digest_string . "&ServerResultURLQueryStringVariables=" . '';

	$digest = sha1($digest_string);

	$process_button_string = 	zen_draw_hidden_field('HashDigest', $digest) .
								zen_draw_hidden_field('MerchantID', MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_ID) .
								zen_draw_hidden_field('Amount', $OrderAmount) .                                       
								zen_draw_hidden_field('CurrencyCode',  $cs_currency) .
								zen_draw_hidden_field('OrderID', $cartID) .
								zen_draw_hidden_field('TransactionType', "SALE") .
								zen_draw_hidden_field('TransactionDateTime', $gatewaydatetime) .
								zen_draw_hidden_field('CallbackURL',  $CallbackURL) .
								zen_draw_hidden_field('OrderDescription',  $OrderDescription) .
								zen_draw_hidden_field('CustomerName',  $CustomerName) .
								zen_draw_hidden_field('Address1', $Address1) .
								zen_draw_hidden_field('Address2', $Address2) .
								zen_draw_hidden_field('Address3', $Address3) .
								zen_draw_hidden_field('Address4', $Address4) .
								zen_draw_hidden_field('City', $City) . 
								zen_draw_hidden_field('State', $State) .
								zen_draw_hidden_field('PostCode', $PostCode) .
								zen_draw_hidden_field('CountryCode', $nCountryCode) .
								zen_draw_hidden_field('CV2Mandatory', $CV2Mandatory) .
								zen_draw_hidden_field('Address1Mandatory', $Address1Mandatory) .
								zen_draw_hidden_field('CityMandatory', $CityMandatory) .
								zen_draw_hidden_field('PostCodeMandatory', $PostCodeMandatory) .
								zen_draw_hidden_field('StateMandatory', $StateMandatory) .
								zen_draw_hidden_field('CountryMandatory', $CountryMandatory) .
								zen_draw_hidden_field('ResultDeliveryMethod', "SERVER") .
								zen_draw_hidden_field('ServerResultURL', $ServerResultURL) .
								zen_draw_hidden_field('PaymentFormDisplaysResult', "FALSE") .
								zen_draw_hidden_field('ServerResultURLCookieVariables', "") .
								zen_draw_hidden_field('ServerResultURLFormVariables', "") .
								zen_draw_hidden_field('ServerResultURLQueryStringVariables', "");
	
	require_once('includes/application_bottom.php');
?>
<html>
<head>
<title>Transfering to PaymentSense</title>
</head>
<body onLoad="payform.submit();">
<form name="payform" action="https://mms.paymentsensegateway.com/Pages/PublicPages/PaymentForm.aspx" method="post">
<?php echo $process_button_string; ?>
</form>
</body>
</html>
</html>